rm(list=ls(all=FALSE))
ls()

library(strucchange)
library(beepr)#; beep(sound = 2, expr = NULL)


#Time difference of 1.171228 hours

################################################################################
workingDirectory = '~/Desktop/RF/V4/'
region = 'v4'

animal.clostridiales<-c("pig",	"cattle",	"sewage", "dog", "ruminant", "herbivore")
animal.bacteroidales<-c("pig",	"cattle",	"sewage", "dog", "ruminant", "herbivore")
FirstMDGNumber = 200

## Random Forest nº1
NbTree1 = 10000
Repeat1 = 100
################################################################################





### Preparation #################################################################
bacterialgroup<-c("clostridiales", "bacteroidales") 
Directory_RF<-paste0(workingDirectory, "RFclassification/")
Directory_training<-paste0(workingDirectory, "data/training/")
Directory_MDG<-paste0(Directory_RF, "MDG/"); dir.create(Directory_MDG)
pre.MDG.animal=0
################################################################################


for (i in 1:length(bacterialgroup)) {
  

  ### Preparation #################################################################
  BacterialGroup<-bacterialgroup[i]
  OutputFilename_MDG_listASV_type<-paste0(Directory_MDG, "list_ASVs_", BacterialGroup, "_MDG_type_", Repeat1, "x_", NbTree1, "trees.txt")
  OutputFilename_MDG_listASV<-paste(Directory_MDG, "list_ASVs_", BacterialGroup,  "_MDG_", Repeat1, "x_", NbTree1, "trees.txt", sep="")
  
  if(BacterialGroup=="clostridiales"){# only works if Clostridiales and Bacteroidales
    animal<-animal.clostridiales
  } else {
    animal<-animal.bacteroidales
  }
  
  

  for (j in 1:length(animal)) {
  
    ### Preparation #################################################################
    Animal=animal[j]
    MDGName<-paste0(Directory_RF, BacterialGroup, "_RF_MDGcomputing_", Repeat1, "x_", NbTree1, "trees/RF_MDG_", BacterialGroup, "_", Animal, ".txt")
    OutputFilename_MDG<-paste0(Directory_MDG, BacterialGroup, "_MDG_", Repeat1, "x_", NbTree1, "trees_", Animal, ".txt")
    ################################################################################
  

    # MDG sequences selection
    MDG<-read.table(MDGName, sep="\t", h=T)
    MDG.threshold<-apply(MDG, 2, function(x) {min(tail(sort(x), FirstMDGNumber))}) # Define the minimum MDG value threshold per repeat (column). In the steps below, only MDG values above that threshold will be taken into account. 
    # This step does not influence the # of ASV that will be selected, but will help to determine the breakpoint in the MDG's plot by reducing the lenght of the tail. If you see the beginning of the tail in the plot (above), you are fine. Other than that, increase the FirstMDGNumber 
    # sort: for each column (repeat), sort values from the smallest (0) to the highest
    # tail: only keep the XXXth last values (XXX = FirstMDGNumber) = pick highest XXXth values
    # min: the minimal value per each column = repeat
    MDG.final<-as.data.frame(lapply(1:Repeat1, function(x) {ifelse(MDG[, x] < MDG.threshold[x], 0, 1)})) # For each cell, is the value is above the threshold previously defined? Yes (1), no (0)
    names(MDG.final)<-names(MDG); row.names(MDG.final)<-row.names(MDG) # Change header/row names
    pre.names.seq.MDG<-names(which(rowSums(MDG.final)>0)) # Select the names of the ASVs that had a MDG score at least once (among all repeats) higher than the threshold
    MDG.sum<-as.data.frame(rowSums(MDG)) # Compute the sum of the MDG score for each ASV (sum-MDG-value)
    MDG.graph<-subset(MDG.sum, rownames(MDG.sum) %in% pre.names.seq.MDG) # Select the sum of the ASV that had been previously selected.
    MDG.graph.sort<--sort(-MDG.graph[,1]) # Sort the sum-MDG-values from the highest to the lowest 
    
    
    # selection based on the breakpoint
    #plot(MDG.graph.sort, at = seq(0,length(MDG.graph.sort), by = 10)) # Plot the sum-MDG-values (1 point = 1 ASV)
    alist<-c(1:length(MDG.graph.sort)) # Create a variable: 1,2,3... to the number of points in the plot
    pre.bp <- breakpoints(MDG.graph.sort~alist, breaks = 1) # Determination of the breakpoint in your plot. All points above the breakpoint are the ASVs that are selected to be part of the classifier  
    #lines(fitted(pre.bp, breaks = 1) ~ alist, col = 4, lwd = 1.5) # Draw the line to see where is the breakpoint. Are you okay with the algorithm? Yes, cool!, No, fix the breakpoint value (= XXXth ASV in which occurs the breakpoint) by yourself
    bp<-pre.bp$breakpoints;bp # Automatically assigned the breakpoint value to the bp variable. If you were not happy with the algorithm, it is the moment to specify the threshold that you think is the best.
    MDG.threshold2<-MDG.graph.sort[bp];MDG.threshold2 # You had the position where the breakpoint was. This line tells you what is the MDG's threshold value.
    names.seq.MDG<-names(which(rowSums(MDG.graph)>=MDG.threshold2)) # All ASVs with a sum-MDG-value above that threshold are selected to be part of the classifier
    length(names.seq.MDG) # Number of ASV into the classifier
    write.table(names.seq.MDG, OutputFilename_MDG, quote = FALSE, sep="\t", row.names = FALSE, col.names = FALSE)
    
    
    # creation of the file containing the list of all ASV selected based on the MDG values
    pre.MDG.animal<-as.data.frame(cbind(names.seq.MDG, matrix(data=Animal, nrow = length(names.seq.MDG), ncol = 1)))
    if(j==1){
      names.seq.MDG.animal<-pre.MDG.animal
    } else {
      names.seq.MDG.animal<-rbind(names.seq.MDG.animal,setNames(pre.MDG.animal,names(names.seq.MDG.animal)))
      #names.seq.MDG.animal<-rbind(names.seq.MDG.animal, pre.MDG.animal)
    }
    names(names.seq.MDG.animal)<-c("SequenceID", "Type")
  }
  write.table(names.seq.MDG.animal, OutputFilename_MDG_listASV_type, quote = FALSE, sep="\t", row.names = FALSE, col.names = TRUE)
  write.table(names.seq.MDG.animal[,1], OutputFilename_MDG_listASV, quote = FALSE, sep="\t", row.names = FALSE, col.names = FALSE)

}
    
    


