rm(list=ls(all=FALSE))
ls()

library(openxlsx)


##########################################################################################
workingDirectory = '~PATH'
region='v6'
bacterialgroup.list<-c('Clostridiales', 'Bacteroidales')
#animal.list<-c('sewage', 'dog', 'pig', 'cattle', 'ruminant', 'herbivore') #V4
animal.list<-c('sewage', 'dog', 'pig', 'deer', 'cattle', 'herbivore') #V6
#animal.list<-c('sewage', 'dog', 'pig', 'ruminant') #V6
##########################################################################################




output<-matrix(NA, nrow=length(animal.list)*length(bacterialgroup.list), ncol=5)



for (i in 1:length(bacterialgroup.list)) { 
  
    BacterialGroup<-bacterialgroup.list[i]
    

    for (j in 1:length(animal.list)) { 
      
        Animal<-animal.list[j]
        x<-ifelse(i==1, j, length(animal.list)+j)
        output[x,1]<-BacterialGroup
        output[x,2]<-Animal
        

        data<-read.table(paste0(workingDirectory, "Predictions_", region, "_paper_", BacterialGroup, "_", Animal, ".txt"), h=T)
        #>names(data)
        #"threshold" "sensitivity" "specificity" #with threshold from 1 to 100%
        data.70<-0
        data.70<-subset(data, sensitivity>=70 & specificity>=70)
        
        if(nrow(data.70)==0){
         
           output[x,3]<-c("none")
           
          }else{
          
            data.70$Sum<-(data.70$sensitivity+data.70$specificity)
            data.70$AbsoluteDifference<-abs(data.70$sensitivity-data.70$specificity)
  
            max.sum<-max(data.70$Sum)
            data.70.max.sum<-subset(data.70, Sum==max.sum)
            
            min.absdiff<-min(data.70$AbsoluteDifference)
            data.70.min.absdiff<-subset(data.70, AbsoluteDifference==min.absdiff)
            
            sensitivity..diff.sum.abs<-abs(mean(data.70.max.sum$sensitivity)-mean(data.70.min.absdiff$sensitivity) )
            specificity..diff.sum.abs<-abs(mean(data.70.max.sum$specificity)-mean(data.70.min.absdiff$specificity) )
            
            if(sensitivity..diff.sum.abs>=specificity..diff.sum.abs){
              if (mean(data.70.max.sum$sensitivity)>=mean(data.70.min.absdiff$sensitivity)){data.70.cutoff<-data.70.max.sum}else{data.70.cutoff<-data.70.min.absdiff}
            } else {
              if (mean(data.70.max.sum$specificity)>=mean(data.70.min.absdiff$specificity)){data.70.cutoff<-data.70.max.sum}else{data.70.cutoff<-data.70.min.absdiff}
            }
              
          
              if(nrow(data.70.cutoff)==1){
                output[x,3]<-data.70.cutoff$theshold
                output[x,4]<-data.70.cutoff$specificity
                output[x,5]<-data.70.cutoff$sensitivity
                
              } else {
                cutoff.value<-round(nrow(data.70.cutoff)*0.1+data.70.cutoff[1,1], digits = 0) # if several values can be used as a decision cut-off, the final cut-off is defined as the number of potential cut-off values * 10% added to the minimum potential cut-off value.   
                data.70.cutoff.value<-subset(data.70.cutoff, theshold==cutoff.value)
                output[x,3]<-cutoff.value
                output[x,4]<-data.70.cutoff.value$specificity
                output[x,5]<-data.70.cutoff.value$sensitivity
                }
          
        }
    }
}
          
     
output.df<-as.data.frame(output)
names(output.df)<-c("bacterialgroup", "source", "cut-off", "specificity", "sensitivity", "TP", "FN", "TN", "FP")
write.table(output.df, paste0(workingDirectory, "cutoff_forensic_", region, ".txt"), quote = FALSE, col.names = TRUE, row.names = FALSE, sep = "\t")
View(output.df)          
          
          
          
          